<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Filter Orders</title>

   <!-- Google Font: Source Sans Pro -->
   <link rel="stylesheet"
   href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  
  <script src="./plugins/jquery/jquery.min.js"></script>
 
</head>
<body onload="onPageLoading()" class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Filter Orders</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index.html" class="brand-link">
      <span class="brand-text font-weight-light">Devcamp</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
              <a href="#" class="nav-link">
                <i class="nav-icon fas fa-th"></i>
                <p>
                  Quản trị danh sách
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="UserList.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>User list</p>
                  </a>
                </li>
              </ul>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="VoucherList.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Voucher list</p>
                  </a>
                </li>
              </ul>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="OrderList.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Order list</p>
                  </a>
                </li>
              </ul>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Filter Order</p>
                  </a>
                </li>
              </ul>
            </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Lọc Orders</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Filter Orders</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="container jumbotron">
          <div class="row form-group">
              <div class="col-md-2">
                  <label for="">Trang thái order</label>
              </div>
              <div class="col-md-3">
                  <select class="form-control" name="" id="select-order-status">
                      <option value="0">(all)</option>
                      <option value="open">open</option>
                      <option value="confirmed">confirmed</option>
                      <option value="cancel">cancel</option>
                  </select>
              </div>
              <div class="col-md-2">
                  <label for="">Loại pizza</label>
              </div>
              <div class="col-md-3">
                  <select class="form-control" name="" id="select-pizza-type">
                      <option value="0">(all)</option>
                      <option value="hawaii">hawaii</option>
                      <option value="bacon">bacon</option>
                      <option value="seafood">seafood</option>
                  </select>
              </div>
              <div class="col-md-2">
                  <button class="btn btn-primary form-control" id="btn-fiter-orders"><i class="fas fa-search"></i>&nbsp; Lọc</button>
              </div>
          </div>
      </div>
      <table class="table table-bordered table-striped table-hover" id="order-users-table">
          <thead class="bg-primary text-light">
              <tr>
                  <th>Order ID</th>
                  <th>Kich co combo</th>
                  <th>Loại pizza</th>
                  <th>Nước uống</th>
                  <th>Thành tiển</th>
                  <th>Họ và tên</th>
                  <th>Số điện thoại</th>
                  <th>Trạng thái</th>
                  <th>Chi tiết</th>
              </tr>
          </thead>
      </table>
      <!-- Modal user detail-->
      <div>
        <div>
          <div id="create-voucher-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Create new voucher</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <form>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="input-create-voucher-code">Voucher code</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="input-create-voucher-code" name="vouchercodes" placeholder="Voucher code" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="input-create-discount">Discount</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="number" id="input-create-discount" name="discount" placeholder="Discount" class="form-control">
                      </div>
                    </div>
                  </form>
                </div>
                <div class="modal-footer">
                  <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                  <button class="btn btn-primary" id="btn-create-voucher">Create Voucher</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        
        <!-- Update voucher modal -->
        <div>
          <div id="update-voucher-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Update a Voucher</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <form>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="input-update-voucher-code">Voucher code</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="input-update-voucher-code" name="vouchercodes" placeholder="Voucher code" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="input-update-discount">Discount</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="number" id="input-update-discount" name="discount" placeholder="Discount" class="form-control">
                      </div>
                    </div>
                  </form>
                </div>
                <div class="modal-footer">
                  <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                  <button class="btn btn-primary" id="btn-update-voucher">Update Voucher</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        
        <!-- Delete confirm modal -->
        <div>
          <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Voucher Delete Confirmation</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <label>Bạn có chắc chắn muốn xóa voucher này không?</label>
                </div>
                <div class="modal-footer">
                  <button class="btn btn-danger" id="btn-confirm-delete-voucher">Confirm</button>
                  <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        
    </div>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->
<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  var gOrderData={
      orders:[],
      filterOrder:function(paramFilterObj){
          //console.log(paramFilterObj)
          var vResult = [];
          //Lọc dữ liệu trên mảng order
          vResult = this.orders.filter(function(order){
              return(
                  //Lọc mảng trang thải
                  ((paramFilterObj.trangThai === "0")||(order.trangThai!=null &&(order.trangThai.toLowerCase().includes(paramFilterObj.trangThai.toLowerCase())))) &&
                  //Lọc mảng pizza
                  ((paramFilterObj.loaiPizza === "0")||(order.loaiPizza!=null && (order.loaiPizza.toLowerCase().includes(paramFilterObj.loaiPizza.toLowerCase()))))
              )
          })
          return vResult;
      }
      
  }
  const gCOLUMN_DATA = ["orderCode","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","chitiet"]
  const gORDER_ID_COL = 0;
  const gKICH_CO_COL = 1;
  const gLOAI_PIZZA_COL = 2;
  const gLOAI_NUOC_UONG_COL = 3;
  const gTHANH_TIEN_COL = 4;
  const gHO_TEN_COL = 5;
  const gSO_DIEN_THOAI_COL = 6;
  const gTRANG_THAI_COL = 7;
  const gACTION_COL = 8;
  var gTable = $("#order-users-table").DataTable({
      columns:[
          {data:gCOLUMN_DATA[gORDER_ID_COL] },
          {data:gCOLUMN_DATA[gKICH_CO_COL] },
          {data:gCOLUMN_DATA[gLOAI_PIZZA_COL] },
          {data:gCOLUMN_DATA[gLOAI_NUOC_UONG_COL] },
          {data:gCOLUMN_DATA[gTHANH_TIEN_COL] },
          {data:gCOLUMN_DATA[gHO_TEN_COL] },
          {data:gCOLUMN_DATA[gSO_DIEN_THOAI_COL] },
          {data:gCOLUMN_DATA[gTRANG_THAI_COL] },
          {data:gCOLUMN_DATA[gACTION_COL] },
      ],
      columnDefs:[
          {
              targets:gACTION_COL,
              render:function(data,type,row,meta){
                  return `<button id="btn-detail" class="btn btn-primary"><i class="fas fa-info"></i>&nbsp;Chi tiết</button>`
              }
          }
      ]
  })
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  //Thêm event handler cho nút chi tiết
  $("#order-users-table").on("click","#btn-detail",onBtnDetailClick);
   //Thêm event handler cho nút lọc
   $("#btn-fiter-orders").on("click",onBtnFilterOrderClick)
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  $(document).ready(function(){
      "use strict";
      callAjaxGetDataOrder();
  })
  //Hàm sữ lý sự kiện cho nút chi tiết
  function onBtnDetailClick(){
      "use strict"
      //Xác định thẻ tr là cha của nút được chọn
      var vRowSelected = $(this).parents('tr');
      //Lấy datatable row
      var vDatatableRow = gTable.row(vRowSelected); 
      //Lấy data của dòng 
      var vUserData = vDatatableRow.data();
      console.log(vUserData)
  }
  //Hàm xữ lý sự kiện cho nút lọc
  function onBtnFilterOrderClick(){
      "use strict";
      //B1:Khai báo biến và thu thập dữ liệu
      var vFlilterObj = {
          trangThai:"",
          loaiPizza:""
      }
      getFilterData(vFlilterObj);
      //console.log(vFlilterObj);
      //B2:Kiểm tra dữ liệu(bỏ qua)

      // B3: Lọc dữ liệu và hiển thị kết quả
      var vFilterOrder = gOrderData.filterOrder(vFlilterObj)
      //console.log(vFilterOrder);
      loadDataToTable(vFilterOrder);
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //Hàm thu thập dữ liệu
  function getFilterData(paramData){
      "use strict";
      paramData.trangThai = $("#select-order-status").val();
      paramData.loaiPizza = $("#select-pizza-type").val();
  }
  //Hàm đổ dữ liệu vào table
  function loadDataToTable(paramData){
      "use strict";
       //Xóa toàn bộ dữ liệu đang có của bảng
      gTable.clear();
       //Cập nhật data cho bảng 
      gTable.rows.add(paramData);
      //Cập nhật lại giao diện hiển thị bảng
      gTable.draw();
  }
  //Hàm hiển thị ra console
  function displayInconsole(paramData){
      "use strict";
      console.log(paramData);
  }
  //Hàm lấy thông tin order từ api
  function callAjaxGetDataOrder(){
      "use strict";
      $.ajax({
          url:gBASE_URL,
          type:"GET",
          dataType:"json",
          success:function(responseObject){
              gOrderData.orders = responseObject;
              //Hiển thị ra console
              displayInconsole(gOrderData.orders);
              //Hiển thị dữ liệu order vào talbe
              loadDataToTable(gOrderData.orders);
          },
          error:function(ajaxContext){
              alert(ajaxContext.responseText);
          }
      })
  }
</script>
</html>
